
// File: index.xml

// File: classDistributionCosine.xml
%feature("docstring") DistributionCosine "

Cosine distribution.

C++ includes: Distributions.h
";

%feature("docstring")  DistributionCosine::DistributionCosine "DistributionCosine::DistributionCosine(std::vector< double > P)
DistributionCosine::DistributionCosine";

%feature("docstring")  DistributionCosine::DistributionCosine "DistributionCosine::DistributionCosine(double mean, double sigma)
DistributionCosine::DistributionCosine";

%feature("docstring")  DistributionCosine::DistributionCosine "DistributionCosine::DistributionCosine()
DistributionCosine::DistributionCosine";

%feature("docstring")  DistributionCosine::clone "DistributionCosine * DistributionCosine::clone() const override
DistributionCosine::clone";

%feature("docstring")  DistributionCosine::className "std::string DistributionCosine::className() const final
DistributionCosine::className
Returns the class name, to be hard-coded in each leaf class that inherits from  INode. 
";

%feature("docstring")  DistributionCosine::parDefs "std::vector< ParaMeta > DistributionCosine::parDefs() const final
DistributionCosine::parDefs
Returns the parameter definitions, to be hard-coded in each leaf class. 
";

%feature("docstring")  DistributionCosine::probabilityDensity "double DistributionCosine::probabilityDensity(double x) const override
DistributionCosine::probabilityDensity
Returns the distribution-specific probability density for value x. 
";

%feature("docstring")  DistributionCosine::mean "double DistributionCosine::mean() const override
DistributionCosine::mean
Returns the distribution-specific mean. 
";

%feature("docstring")  DistributionCosine::sigma "double DistributionCosine::sigma() const
DistributionCosine::sigma";

%feature("docstring")  DistributionCosine::equidistantPoints "std::vector< double > DistributionCosine::equidistantPoints(size_t nbr_samples, double sigma_factor, const RealLimits &limits={}) const override
DistributionCosine::equidistantPoints
generate list of sample values 
";

%feature("docstring")  DistributionCosine::isDelta "bool DistributionCosine::isDelta() const override
DistributionCosine::isDelta
Returns true if the distribution is in the limit case of a Dirac delta distribution. 
";

%feature("docstring")  DistributionCosine::pythonConstructor "std::string DistributionCosine::pythonConstructor(const std::string &units) const override
DistributionCosine::pythonConstructor
Prints distribution with constructor parameters in given units. ba.DistributionGaussian(2.0*deg, 0.02*deg) 
";

%feature("docstring")  DistributionCosine::validate "std::string DistributionCosine::validate() const override
DistributionCosine::validate";


// File: classDistributionGate.xml
%feature("docstring") DistributionGate "

Uniform distribution function with half width hwhm.

C++ includes: Distributions.h
";

%feature("docstring")  DistributionGate::DistributionGate "DistributionGate::DistributionGate(std::vector< double > P)
DistributionGate::DistributionGate";

%feature("docstring")  DistributionGate::DistributionGate "DistributionGate::DistributionGate(double min, double max)
DistributionGate::DistributionGate";

%feature("docstring")  DistributionGate::DistributionGate "DistributionGate::DistributionGate()
DistributionGate::DistributionGate";

%feature("docstring")  DistributionGate::clone "DistributionGate * DistributionGate::clone() const override
DistributionGate::clone";

%feature("docstring")  DistributionGate::className "std::string DistributionGate::className() const final
DistributionGate::className
Returns the class name, to be hard-coded in each leaf class that inherits from  INode. 
";

%feature("docstring")  DistributionGate::parDefs "std::vector< ParaMeta > DistributionGate::parDefs() const final
DistributionGate::parDefs
Returns the parameter definitions, to be hard-coded in each leaf class. 
";

%feature("docstring")  DistributionGate::probabilityDensity "double DistributionGate::probabilityDensity(double x) const override
DistributionGate::probabilityDensity
Returns the distribution-specific probability density for value x. 
";

%feature("docstring")  DistributionGate::mean "double DistributionGate::mean() const override
DistributionGate::mean
Returns the distribution-specific mean. 
";

%feature("docstring")  DistributionGate::min "double DistributionGate::min() const
DistributionGate::min";

%feature("docstring")  DistributionGate::max "double DistributionGate::max() const
DistributionGate::max";

%feature("docstring")  DistributionGate::equidistantPoints "std::vector< double > DistributionGate::equidistantPoints(size_t nbr_samples, double sigma_factor, const RealLimits &limits={}) const override
DistributionGate::equidistantPoints
Returns list of sample values. 
";

%feature("docstring")  DistributionGate::isDelta "bool DistributionGate::isDelta() const override
DistributionGate::isDelta
Returns true if the distribution is in the limit case of a Dirac delta distribution. 
";

%feature("docstring")  DistributionGate::pythonConstructor "std::string DistributionGate::pythonConstructor(const std::string &units) const override
DistributionGate::pythonConstructor
Prints distribution with constructor parameters in given units. ba.DistributionGaussian(2.0*deg, 0.02*deg) 
";

%feature("docstring")  DistributionGate::validate "std::string DistributionGate::validate() const override
DistributionGate::validate";


// File: classDistributionGaussian.xml
%feature("docstring") DistributionGaussian "

Gaussian distribution with standard deviation std_dev.

C++ includes: Distributions.h
";

%feature("docstring")  DistributionGaussian::DistributionGaussian "DistributionGaussian::DistributionGaussian(std::vector< double > P)
DistributionGaussian::DistributionGaussian";

%feature("docstring")  DistributionGaussian::DistributionGaussian "DistributionGaussian::DistributionGaussian(double mean, double std_dev)
DistributionGaussian::DistributionGaussian";

%feature("docstring")  DistributionGaussian::DistributionGaussian "DistributionGaussian::DistributionGaussian()
DistributionGaussian::DistributionGaussian";

%feature("docstring")  DistributionGaussian::clone "DistributionGaussian * DistributionGaussian::clone() const override
DistributionGaussian::clone";

%feature("docstring")  DistributionGaussian::className "std::string DistributionGaussian::className() const final
DistributionGaussian::className
Returns the class name, to be hard-coded in each leaf class that inherits from  INode. 
";

%feature("docstring")  DistributionGaussian::parDefs "std::vector< ParaMeta > DistributionGaussian::parDefs() const final
DistributionGaussian::parDefs
Returns the parameter definitions, to be hard-coded in each leaf class. 
";

%feature("docstring")  DistributionGaussian::probabilityDensity "double DistributionGaussian::probabilityDensity(double x) const override
DistributionGaussian::probabilityDensity
Returns the distribution-specific probability density for value x. 
";

%feature("docstring")  DistributionGaussian::mean "double DistributionGaussian::mean() const override
DistributionGaussian::mean
Returns the distribution-specific mean. 
";

%feature("docstring")  DistributionGaussian::getStdDev "double DistributionGaussian::getStdDev() const
DistributionGaussian::getStdDev";

%feature("docstring")  DistributionGaussian::equidistantPoints "std::vector< double > DistributionGaussian::equidistantPoints(size_t nbr_samples, double sigma_factor, const RealLimits &limits={}) const override
DistributionGaussian::equidistantPoints
generate list of sample values 
";

%feature("docstring")  DistributionGaussian::isDelta "bool DistributionGaussian::isDelta() const override
DistributionGaussian::isDelta
Returns true if the distribution is in the limit case of a Dirac delta distribution. 
";

%feature("docstring")  DistributionGaussian::pythonConstructor "std::string DistributionGaussian::pythonConstructor(const std::string &units) const override
DistributionGaussian::pythonConstructor
Prints distribution with constructor parameters in given units. ba.DistributionGaussian(2.0*deg, 0.02*deg) 
";

%feature("docstring")  DistributionGaussian::validate "std::string DistributionGaussian::validate() const override
DistributionGaussian::validate";


// File: classDistributionHandler.xml
%feature("docstring") DistributionHandler "

Provides the functionality to average over parameter distributions with weights.

C++ includes: DistributionHandler.h
";

%feature("docstring")  DistributionHandler::DistributionHandler "DistributionHandler::DistributionHandler()
DistributionHandler::DistributionHandler";

%feature("docstring")  DistributionHandler::~DistributionHandler "DistributionHandler::~DistributionHandler()
DistributionHandler::~DistributionHandler";

%feature("docstring")  DistributionHandler::addParameterDistribution "void DistributionHandler::addParameterDistribution(const ParameterDistribution &par_distr)
DistributionHandler::addParameterDistribution";

%feature("docstring")  DistributionHandler::getTotalNumberOfSamples "size_t DistributionHandler::getTotalNumberOfSamples() const
DistributionHandler::getTotalNumberOfSamples
get the total number of parameter value combinations (product of the individual sizes of each parameter distribution 
";

%feature("docstring")  DistributionHandler::setParameterValues "double DistributionHandler::setParameterValues(size_t index)
DistributionHandler::setParameterValues
set the parameter values of the simulation object to a specific combination of values, determined by the index (which must be smaller than the total number of combinations) and returns the weight associated with this combination of parameter values. initParameterLinks() has to be called before this! 
";

%feature("docstring")  DistributionHandler::getDistributions "const std::vector< ParameterDistribution > & DistributionHandler::getDistributions() const
DistributionHandler::getDistributions";

%feature("docstring")  DistributionHandler::defineCallbackForDistribution "void DistributionHandler::defineCallbackForDistribution(const ParameterDistribution *distribution, std::function< void(double)> fn)
DistributionHandler::defineCallbackForDistribution";


// File: classDistributionLogNormal.xml
%feature("docstring") DistributionLogNormal "

Log-normal distribution.

C++ includes: Distributions.h
";

%feature("docstring")  DistributionLogNormal::DistributionLogNormal "DistributionLogNormal::DistributionLogNormal(std::vector< double > P)
DistributionLogNormal::DistributionLogNormal";

%feature("docstring")  DistributionLogNormal::DistributionLogNormal "DistributionLogNormal::DistributionLogNormal(double median, double scale_param)
DistributionLogNormal::DistributionLogNormal";

%feature("docstring")  DistributionLogNormal::clone "DistributionLogNormal * DistributionLogNormal::clone() const override
DistributionLogNormal::clone";

%feature("docstring")  DistributionLogNormal::className "std::string DistributionLogNormal::className() const final
DistributionLogNormal::className
Returns the class name, to be hard-coded in each leaf class that inherits from  INode. 
";

%feature("docstring")  DistributionLogNormal::parDefs "std::vector< ParaMeta > DistributionLogNormal::parDefs() const final
DistributionLogNormal::parDefs
Returns the parameter definitions, to be hard-coded in each leaf class. 
";

%feature("docstring")  DistributionLogNormal::probabilityDensity "double DistributionLogNormal::probabilityDensity(double x) const override
DistributionLogNormal::probabilityDensity
Returns the distribution-specific probability density for value x. 
";

%feature("docstring")  DistributionLogNormal::mean "double DistributionLogNormal::mean() const override
DistributionLogNormal::mean
Returns the distribution-specific mean. 
";

%feature("docstring")  DistributionLogNormal::getMedian "double DistributionLogNormal::getMedian() const
DistributionLogNormal::getMedian";

%feature("docstring")  DistributionLogNormal::getScalePar "double DistributionLogNormal::getScalePar() const
DistributionLogNormal::getScalePar";

%feature("docstring")  DistributionLogNormal::equidistantPoints "std::vector< double > DistributionLogNormal::equidistantPoints(size_t nbr_samples, double sigma_factor, const RealLimits &limits={}) const override
DistributionLogNormal::equidistantPoints
generate list of sample values 
";

%feature("docstring")  DistributionLogNormal::isDelta "bool DistributionLogNormal::isDelta() const override
DistributionLogNormal::isDelta
Returns true if the distribution is in the limit case of a Dirac delta distribution. 
";

%feature("docstring")  DistributionLogNormal::pythonConstructor "std::string DistributionLogNormal::pythonConstructor(const std::string &units) const override
DistributionLogNormal::pythonConstructor
Prints distribution with constructor parameters in given units. ba.DistributionGaussian(2.0*deg, 0.02*deg) 
";

%feature("docstring")  DistributionLogNormal::validate "std::string DistributionLogNormal::validate() const override
DistributionLogNormal::validate";


// File: classDistributionLorentz.xml
%feature("docstring") DistributionLorentz "

Lorentz distribution with half width hwhm.

C++ includes: Distributions.h
";

%feature("docstring")  DistributionLorentz::DistributionLorentz "DistributionLorentz::DistributionLorentz(std::vector< double > P)
DistributionLorentz::DistributionLorentz";

%feature("docstring")  DistributionLorentz::DistributionLorentz "DistributionLorentz::DistributionLorentz(double mean, double hwhm)
DistributionLorentz::DistributionLorentz";

%feature("docstring")  DistributionLorentz::DistributionLorentz "DistributionLorentz::DistributionLorentz()
DistributionLorentz::DistributionLorentz";

%feature("docstring")  DistributionLorentz::clone "DistributionLorentz * DistributionLorentz::clone() const override
DistributionLorentz::clone";

%feature("docstring")  DistributionLorentz::className "std::string DistributionLorentz::className() const final
DistributionLorentz::className
Returns the class name, to be hard-coded in each leaf class that inherits from  INode. 
";

%feature("docstring")  DistributionLorentz::parDefs "std::vector< ParaMeta > DistributionLorentz::parDefs() const final
DistributionLorentz::parDefs
Returns the parameter definitions, to be hard-coded in each leaf class. 
";

%feature("docstring")  DistributionLorentz::probabilityDensity "double DistributionLorentz::probabilityDensity(double x) const override
DistributionLorentz::probabilityDensity
Returns the distribution-specific probability density for value x. 
";

%feature("docstring")  DistributionLorentz::mean "double DistributionLorentz::mean() const override
DistributionLorentz::mean
Returns the distribution-specific mean. 
";

%feature("docstring")  DistributionLorentz::hwhm "double DistributionLorentz::hwhm() const
DistributionLorentz::hwhm";

%feature("docstring")  DistributionLorentz::equidistantPoints "std::vector< double > DistributionLorentz::equidistantPoints(size_t nbr_samples, double sigma_factor, const RealLimits &limits={}) const override
DistributionLorentz::equidistantPoints
generate list of sample values 
";

%feature("docstring")  DistributionLorentz::isDelta "bool DistributionLorentz::isDelta() const override
DistributionLorentz::isDelta
Returns true if the distribution is in the limit case of a Dirac delta distribution. 
";

%feature("docstring")  DistributionLorentz::pythonConstructor "std::string DistributionLorentz::pythonConstructor(const std::string &units) const override
DistributionLorentz::pythonConstructor
Prints distribution with constructor parameters in given units. ba.DistributionGaussian(2.0*deg, 0.02*deg) 
";

%feature("docstring")  DistributionLorentz::validate "std::string DistributionLorentz::validate() const override
DistributionLorentz::validate";


// File: classDistributionTrapezoid.xml
%feature("docstring") DistributionTrapezoid "

Trapezoidal distribution.

C++ includes: Distributions.h
";

%feature("docstring")  DistributionTrapezoid::DistributionTrapezoid "DistributionTrapezoid::DistributionTrapezoid(std::vector< double > P)
DistributionTrapezoid::DistributionTrapezoid";

%feature("docstring")  DistributionTrapezoid::DistributionTrapezoid "DistributionTrapezoid::DistributionTrapezoid(double center, double left, double middle, double right)
DistributionTrapezoid::DistributionTrapezoid";

%feature("docstring")  DistributionTrapezoid::DistributionTrapezoid "DistributionTrapezoid::DistributionTrapezoid()
DistributionTrapezoid::DistributionTrapezoid";

%feature("docstring")  DistributionTrapezoid::clone "DistributionTrapezoid * DistributionTrapezoid::clone() const override
DistributionTrapezoid::clone";

%feature("docstring")  DistributionTrapezoid::className "std::string DistributionTrapezoid::className() const final
DistributionTrapezoid::className
Returns the class name, to be hard-coded in each leaf class that inherits from  INode. 
";

%feature("docstring")  DistributionTrapezoid::parDefs "std::vector< ParaMeta > DistributionTrapezoid::parDefs() const final
DistributionTrapezoid::parDefs
Returns the parameter definitions, to be hard-coded in each leaf class. 
";

%feature("docstring")  DistributionTrapezoid::probabilityDensity "double DistributionTrapezoid::probabilityDensity(double x) const override
DistributionTrapezoid::probabilityDensity
Returns the distribution-specific probability density for value x. 
";

%feature("docstring")  DistributionTrapezoid::mean "double DistributionTrapezoid::mean() const override
DistributionTrapezoid::mean
Returns the distribution-specific mean. 
";

%feature("docstring")  DistributionTrapezoid::getLeftWidth "double DistributionTrapezoid::getLeftWidth() const
DistributionTrapezoid::getLeftWidth";

%feature("docstring")  DistributionTrapezoid::getMiddleWidth "double DistributionTrapezoid::getMiddleWidth() const
DistributionTrapezoid::getMiddleWidth";

%feature("docstring")  DistributionTrapezoid::getRightWidth "double DistributionTrapezoid::getRightWidth() const
DistributionTrapezoid::getRightWidth";

%feature("docstring")  DistributionTrapezoid::equidistantPoints "std::vector< double > DistributionTrapezoid::equidistantPoints(size_t nbr_samples, double sigma_factor, const RealLimits &limits={}) const override
DistributionTrapezoid::equidistantPoints
generate list of sample values 
";

%feature("docstring")  DistributionTrapezoid::isDelta "bool DistributionTrapezoid::isDelta() const override
DistributionTrapezoid::isDelta
Returns true if the distribution is in the limit case of a Dirac delta distribution. 
";

%feature("docstring")  DistributionTrapezoid::pythonConstructor "std::string DistributionTrapezoid::pythonConstructor(const std::string &units) const override
DistributionTrapezoid::pythonConstructor
Prints distribution with constructor parameters in given units. ba.DistributionGaussian(2.0*deg, 0.02*deg) 
";

%feature("docstring")  DistributionTrapezoid::validate "std::string DistributionTrapezoid::validate() const override
DistributionTrapezoid::validate";


// File: classIDistribution1D.xml
%feature("docstring") IDistribution1D "

Interface for one-dimensional distributions.

C++ includes: Distributions.h
";

%feature("docstring")  IDistribution1D::IDistribution1D "IDistribution1D::IDistribution1D(const std::vector< double > &PValues)
IDistribution1D::IDistribution1D";

%feature("docstring")  IDistribution1D::clone "IDistribution1D * IDistribution1D::clone() const override=0
IDistribution1D::clone";

%feature("docstring")  IDistribution1D::probabilityDensity "virtual double IDistribution1D::probabilityDensity(double x) const =0
IDistribution1D::probabilityDensity
Returns the distribution-specific probability density for value x. 
";

%feature("docstring")  IDistribution1D::mean "virtual double IDistribution1D::mean() const =0
IDistribution1D::mean
Returns the distribution-specific mean. 
";

%feature("docstring")  IDistribution1D::equidistantSamples "std::vector< ParameterSample > IDistribution1D::equidistantSamples(size_t nbr_samples, double sigma_factor=0., const RealLimits &limits={}) const
IDistribution1D::equidistantSamples
Returns equidistant samples, using intrinsic parameters, weighted with  probabilityDensity(). 
";

%feature("docstring")  IDistribution1D::equidistantSamplesInRange "std::vector< ParameterSample > IDistribution1D::equidistantSamplesInRange(size_t nbr_samples, double xmin, double xmax) const
IDistribution1D::equidistantSamplesInRange
Returns equidistant samples from xmin to xmax, weighted with  probabilityDensity(). 
";

%feature("docstring")  IDistribution1D::equidistantPoints "virtual std::vector< double > IDistribution1D::equidistantPoints(size_t nbr_samples, double sigma_factor, const RealLimits &limits={}) const =0
IDistribution1D::equidistantPoints
Returns equidistant interpolation points, with range computed in distribution-specific way from mean and width parameter, taking into account limits and sigma_factor. 
";

%feature("docstring")  IDistribution1D::equidistantPointsInRange "std::vector< double > IDistribution1D::equidistantPointsInRange(size_t nbr_samples, double xmin, double xmax) const
IDistribution1D::equidistantPointsInRange
Returns equidistant interpolation points from xmin to xmax. 
";

%feature("docstring")  IDistribution1D::isDelta "virtual bool IDistribution1D::isDelta() const =0
IDistribution1D::isDelta
Returns true if the distribution is in the limit case of a Dirac delta distribution. 
";

%feature("docstring")  IDistribution1D::pythonConstructor "virtual std::string IDistribution1D::pythonConstructor(const std::string &units) const =0
IDistribution1D::pythonConstructor
Prints distribution with constructor parameters in given units. ba.DistributionGaussian(2.0*deg, 0.02*deg) 
";


// File: classINode.xml
%feature("docstring") INode "

Base class for tree-like structures containing parameterized objects.

C++ includes: INode.h
";

%feature("docstring")  INode::INode "INode::INode()=default
INode::INode";

%feature("docstring")  INode::INode "INode::INode(std::vector< double > PValues)
INode::INode";

%feature("docstring")  INode::~INode "virtual INode::~INode()=default
INode::~INode";

%feature("docstring")  INode::className "virtual std::string INode::className() const =0
INode::className
Returns the class name, to be hard-coded in each leaf class that inherits from  INode. 
";

%feature("docstring")  INode::parDefs "virtual std::vector< ParaMeta > INode::parDefs() const
INode::parDefs
Returns the parameter definitions, to be hard-coded in each leaf class. 
";

%feature("docstring")  INode::nodeChildren "std::vector< const INode * > INode::nodeChildren() const
INode::nodeChildren
Returns all children. 
";

%feature("docstring")  INode::nodeOffspring "std::vector< const INode * > INode::nodeOffspring() const
INode::nodeOffspring
Returns all descendants. // TODO sep22: rm if it remains UNUSED. 
";

%feature("docstring")  INode::jointError "std::string INode::jointError(const std::vector< std::string > errs) const
INode::jointError";

%feature("docstring")  INode::validate "virtual std::string INode::validate() const
INode::validate";

%feature("docstring")  INode::validateOrThrow "void INode::validateOrThrow() const
INode::validateOrThrow";


// File: classIRangedDistribution.xml
%feature("docstring") IRangedDistribution "

Interface for one-dimensional ranged distributions. All derived distributions allow for generating samples in-place for known mean and standard deviation (except for  RangedDistributionLorentz which uses median and hwhm).

C++ includes: RangedDistributions.h
";

%feature("docstring")  IRangedDistribution::IRangedDistribution "IRangedDistribution::IRangedDistribution()
IRangedDistribution::IRangedDistribution";

%feature("docstring")  IRangedDistribution::IRangedDistribution "IRangedDistribution::IRangedDistribution(size_t n_samples, double sigma_factor, const RealLimits &limits=RealLimits::limitless())
IRangedDistribution::IRangedDistribution";

%feature("docstring")  IRangedDistribution::IRangedDistribution "IRangedDistribution::IRangedDistribution(size_t n_samples, double sigma_factor, double min, double max)
IRangedDistribution::IRangedDistribution
Initializes Ranged distribution with given number of samples, sigma factor (range in standard deviations to take into account during sample generation) and limits (either RealLimits object or just min and max limits). By default  n_samples = 5,  sigma_factor = 2.0, while the limits are (-inf, +inf). 
";

%feature("docstring")  IRangedDistribution::clone "IRangedDistribution * IRangedDistribution::clone() const override=0
IRangedDistribution::clone";

%feature("docstring")  IRangedDistribution::~IRangedDistribution "IRangedDistribution::~IRangedDistribution() override
IRangedDistribution::~IRangedDistribution";

%feature("docstring")  IRangedDistribution::generateSamples "std::vector< ParameterSample > IRangedDistribution::generateSamples(double mean, double stddev) const
IRangedDistribution::generateSamples";

%feature("docstring")  IRangedDistribution::generateSamples "std::vector< std::vector< ParameterSample > > IRangedDistribution::generateSamples(const std::vector< double > &mean, const std::vector< double > &stddev) const
IRangedDistribution::generateSamples
Generates list of sampled values with their weights from given means and standard deviations. 
";

%feature("docstring")  IRangedDistribution::distribution "IDistribution1D * IRangedDistribution::distribution(double mean, double stddev) const
IRangedDistribution::distribution
Public interface function to underlying  IDistribution1D object. 
";

%feature("docstring")  IRangedDistribution::limits "RealLimits IRangedDistribution::limits() const
IRangedDistribution::limits
Returns current limits of the distribution. 
";

%feature("docstring")  IRangedDistribution::sigmaFactor "double IRangedDistribution::sigmaFactor() const
IRangedDistribution::sigmaFactor
Returns sigma factor to use during sampling. 
";

%feature("docstring")  IRangedDistribution::nSamples "size_t IRangedDistribution::nSamples() const
IRangedDistribution::nSamples
Returns number of samples to generate. 
";

%feature("docstring")  IRangedDistribution::setLimits "void IRangedDistribution::setLimits(const RealLimits &limits)
IRangedDistribution::setLimits";

%feature("docstring")  IRangedDistribution::name "virtual std::string IRangedDistribution::name() const =0
IRangedDistribution::name
Returns distribution name for python-formatted text. 
";


// File: structParaMeta.xml
%feature("docstring") ParaMeta "

Metadata of one model parameter.

C++ includes: INode.h
";


// File: classParameterDistribution.xml
%feature("docstring") ParameterDistribution "

A parametric distribution function, for use with any model parameter.

C++ includes: ParameterDistribution.h
";

%feature("docstring")  ParameterDistribution::ParameterDistribution "ParameterDistribution::ParameterDistribution(WhichParameter whichParameter, const IDistribution1D &distribution, size_t nbr_samples, double sigma_factor=0.0, const RealLimits &limits=RealLimits())
ParameterDistribution::ParameterDistribution";

%feature("docstring")  ParameterDistribution::ParameterDistribution "ParameterDistribution::ParameterDistribution(WhichParameter whichParameter, const IDistribution1D &distribution, size_t nbr_samples, double xmin, double xmax)
ParameterDistribution::ParameterDistribution";

%feature("docstring")  ParameterDistribution::ParameterDistribution "ParameterDistribution::ParameterDistribution(const ParameterDistribution &other)
ParameterDistribution::ParameterDistribution";

%feature("docstring")  ParameterDistribution::~ParameterDistribution "ParameterDistribution::~ParameterDistribution()
ParameterDistribution::~ParameterDistribution";

%feature("docstring")  ParameterDistribution::whichParameter "ParameterDistribution::WhichParameter ParameterDistribution::whichParameter() const
ParameterDistribution::whichParameter";

%feature("docstring")  ParameterDistribution::whichParameterAsPyEnum "std::string ParameterDistribution::whichParameterAsPyEnum() const
ParameterDistribution::whichParameterAsPyEnum";

%feature("docstring")  ParameterDistribution::nDraws "size_t ParameterDistribution::nDraws() const
ParameterDistribution::nDraws
get number of samples for this distribution 
";

%feature("docstring")  ParameterDistribution::sigmaFactor "double ParameterDistribution::sigmaFactor() const
ParameterDistribution::sigmaFactor
get the sigma factor 
";

%feature("docstring")  ParameterDistribution::getDistribution "const IDistribution1D * ParameterDistribution::getDistribution() const
ParameterDistribution::getDistribution";

%feature("docstring")  ParameterDistribution::getDistribution "IDistribution1D * ParameterDistribution::getDistribution()
ParameterDistribution::getDistribution";

%feature("docstring")  ParameterDistribution::generateSamples "std::vector< ParameterSample > ParameterDistribution::generateSamples() const
ParameterDistribution::generateSamples
generate list of sampled values with their weight 
";

%feature("docstring")  ParameterDistribution::getLimits "RealLimits ParameterDistribution::getLimits() const
ParameterDistribution::getLimits";

%feature("docstring")  ParameterDistribution::getMinValue "double ParameterDistribution::getMinValue() const
ParameterDistribution::getMinValue";

%feature("docstring")  ParameterDistribution::getMaxValue "double ParameterDistribution::getMaxValue() const
ParameterDistribution::getMaxValue";


// File: classParameterSample.xml
%feature("docstring") ParameterSample "

A parameter value with a weight, as obtained when sampling from a distribution.

C++ includes: ParameterSample.h
";

%feature("docstring")  ParameterSample::ParameterSample "ParameterSample::ParameterSample(double _value, double _weight=1)
ParameterSample::ParameterSample";


// File: classRangedDistributionCosine.xml
%feature("docstring") RangedDistributionCosine "

Cosine distribution.

C++ includes: RangedDistributions.h
";

%feature("docstring")  RangedDistributionCosine::RangedDistributionCosine "RangedDistributionCosine::RangedDistributionCosine()
RangedDistributionCosine::RangedDistributionCosine";

%feature("docstring")  RangedDistributionCosine::RangedDistributionCosine "RangedDistributionCosine::RangedDistributionCosine(size_t n_samples, double sigma_factor, const RealLimits &limits=RealLimits::limitless())
RangedDistributionCosine::RangedDistributionCosine";

%feature("docstring")  RangedDistributionCosine::RangedDistributionCosine "RangedDistributionCosine::RangedDistributionCosine(size_t n_samples, double sigma_factor, double min, double max)
RangedDistributionCosine::RangedDistributionCosine
Initializes Ranged distribution with given number of samples, sigma factor (range in standard deviations to take into account during sample generation) and limits (either RealLimits object or just min and max limits). By default  n_samples = 5,  sigma_factor = 2.0, while the limits are (-inf, +inf). 
";

%feature("docstring")  RangedDistributionCosine::clone "RangedDistributionCosine * RangedDistributionCosine::clone() const override
RangedDistributionCosine::clone";

%feature("docstring")  RangedDistributionCosine::~RangedDistributionCosine "RangedDistributionCosine::~RangedDistributionCosine() override=default
RangedDistributionCosine::~RangedDistributionCosine";

%feature("docstring")  RangedDistributionCosine::name "std::string RangedDistributionCosine::name() const override
RangedDistributionCosine::name
Returns distribution name for python-formatted text. 
";


// File: classRangedDistributionGate.xml
%feature("docstring") RangedDistributionGate "

Uniform distribution function.

C++ includes: RangedDistributions.h
";

%feature("docstring")  RangedDistributionGate::RangedDistributionGate "RangedDistributionGate::RangedDistributionGate()
RangedDistributionGate::RangedDistributionGate";

%feature("docstring")  RangedDistributionGate::RangedDistributionGate "RangedDistributionGate::RangedDistributionGate(size_t n_samples, double sigma_factor, const RealLimits &limits=RealLimits::limitless())
RangedDistributionGate::RangedDistributionGate";

%feature("docstring")  RangedDistributionGate::RangedDistributionGate "RangedDistributionGate::RangedDistributionGate(size_t n_samples, double sigma_factor, double min, double max)
RangedDistributionGate::RangedDistributionGate
Initializes Ranged distribution with given number of samples, sigma factor (range in standard deviations to take into account during sample generation) and limits (either RealLimits object or just min and max limits). By default  n_samples = 5,  sigma_factor = 2.0, while the limits are (-inf, +inf). 
";

%feature("docstring")  RangedDistributionGate::clone "RangedDistributionGate * RangedDistributionGate::clone() const override
RangedDistributionGate::clone";

%feature("docstring")  RangedDistributionGate::~RangedDistributionGate "RangedDistributionGate::~RangedDistributionGate() override=default
RangedDistributionGate::~RangedDistributionGate";

%feature("docstring")  RangedDistributionGate::name "std::string RangedDistributionGate::name() const override
RangedDistributionGate::name
Returns distribution name for python-formatted text. 
";


// File: classRangedDistributionGaussian.xml
%feature("docstring") RangedDistributionGaussian "

Gaussian distribution with standard deviation std_dev.

C++ includes: RangedDistributions.h
";

%feature("docstring")  RangedDistributionGaussian::RangedDistributionGaussian "RangedDistributionGaussian::RangedDistributionGaussian()
RangedDistributionGaussian::RangedDistributionGaussian";

%feature("docstring")  RangedDistributionGaussian::RangedDistributionGaussian "RangedDistributionGaussian::RangedDistributionGaussian(size_t n_samples, double sigma_factor, const RealLimits &limits=RealLimits::limitless())
RangedDistributionGaussian::RangedDistributionGaussian";

%feature("docstring")  RangedDistributionGaussian::RangedDistributionGaussian "RangedDistributionGaussian::RangedDistributionGaussian(size_t n_samples, double sigma_factor, double min, double max)
RangedDistributionGaussian::RangedDistributionGaussian
Initializes Ranged distribution with given number of samples, sigma factor (range in standard deviations to take into account during sample generation) and limits (either RealLimits object or just min and max limits). By default  n_samples = 5,  sigma_factor = 2.0, while the limits are (-inf, +inf). 
";

%feature("docstring")  RangedDistributionGaussian::clone "RangedDistributionGaussian * RangedDistributionGaussian::clone() const override
RangedDistributionGaussian::clone";

%feature("docstring")  RangedDistributionGaussian::~RangedDistributionGaussian "RangedDistributionGaussian::~RangedDistributionGaussian() override=default
RangedDistributionGaussian::~RangedDistributionGaussian";

%feature("docstring")  RangedDistributionGaussian::name "std::string RangedDistributionGaussian::name() const override
RangedDistributionGaussian::name
Returns distribution name for python-formatted text. 
";


// File: classRangedDistributionLogNormal.xml
%feature("docstring") RangedDistributionLogNormal "

Log-normal distribution.

C++ includes: RangedDistributions.h
";

%feature("docstring")  RangedDistributionLogNormal::RangedDistributionLogNormal "RangedDistributionLogNormal::RangedDistributionLogNormal()
RangedDistributionLogNormal::RangedDistributionLogNormal";

%feature("docstring")  RangedDistributionLogNormal::RangedDistributionLogNormal "RangedDistributionLogNormal::RangedDistributionLogNormal(size_t n_samples, double sigma_factor, const RealLimits &limits=RealLimits::limitless())
RangedDistributionLogNormal::RangedDistributionLogNormal";

%feature("docstring")  RangedDistributionLogNormal::RangedDistributionLogNormal "RangedDistributionLogNormal::RangedDistributionLogNormal(size_t n_samples, double sigma_factor, double min, double max)
RangedDistributionLogNormal::RangedDistributionLogNormal
Initializes Ranged distribution with given number of samples, sigma factor (range in standard deviations to take into account during sample generation) and limits (either RealLimits object or just min and max limits). By default  n_samples = 5,  sigma_factor = 2.0, while the limits are (-inf, +inf). 
";

%feature("docstring")  RangedDistributionLogNormal::clone "RangedDistributionLogNormal * RangedDistributionLogNormal::clone() const override
RangedDistributionLogNormal::clone";

%feature("docstring")  RangedDistributionLogNormal::~RangedDistributionLogNormal "RangedDistributionLogNormal::~RangedDistributionLogNormal() override=default
RangedDistributionLogNormal::~RangedDistributionLogNormal";

%feature("docstring")  RangedDistributionLogNormal::name "std::string RangedDistributionLogNormal::name() const override
RangedDistributionLogNormal::name
Returns distribution name for python-formatted text. 
";


// File: classRangedDistributionLorentz.xml
%feature("docstring") RangedDistributionLorentz "

Lorentz distribution with median and hwhm.

C++ includes: RangedDistributions.h
";

%feature("docstring")  RangedDistributionLorentz::RangedDistributionLorentz "RangedDistributionLorentz::RangedDistributionLorentz()
RangedDistributionLorentz::RangedDistributionLorentz";

%feature("docstring")  RangedDistributionLorentz::RangedDistributionLorentz "RangedDistributionLorentz::RangedDistributionLorentz(size_t n_samples, double hwhm_factor, const RealLimits &limits=RealLimits::limitless())
RangedDistributionLorentz::RangedDistributionLorentz";

%feature("docstring")  RangedDistributionLorentz::RangedDistributionLorentz "RangedDistributionLorentz::RangedDistributionLorentz(size_t n_samples, double hwhm_factor, double min, double max)
RangedDistributionLorentz::RangedDistributionLorentz
Initializes Ranged distribution with given number of samples, sigma factor (range in standard deviations to take into account during sample generation) and limits (either RealLimits object or just min and max limits). By default  n_samples = 5,  hwhm_factor = 2.0, while the limits are (-inf, +inf). 
";

%feature("docstring")  RangedDistributionLorentz::clone "RangedDistributionLorentz * RangedDistributionLorentz::clone() const override
RangedDistributionLorentz::clone";

%feature("docstring")  RangedDistributionLorentz::~RangedDistributionLorentz "RangedDistributionLorentz::~RangedDistributionLorentz() override=default
RangedDistributionLorentz::~RangedDistributionLorentz";

%feature("docstring")  RangedDistributionLorentz::name "std::string RangedDistributionLorentz::name() const override
RangedDistributionLorentz::name
Returns distribution name for python-formatted text. 
";


// File: namespace_0d2.xml


// File: namespace_0d7.xml


// File: namespaceNodeUtils.xml
%feature("docstring")  NodeUtils::ChildNodesOfType "std::vector< const T * > NodeUtils::ChildNodesOfType(const INode &node)
NodeUtils::ChildNodesOfType";

%feature("docstring")  NodeUtils::OnlyChildOfType "const T * NodeUtils::OnlyChildOfType(const INode &node)
NodeUtils::OnlyChildOfType";

%feature("docstring")  NodeUtils::AllDescendantsOfType "std::vector< const T * > NodeUtils::AllDescendantsOfType(const INode &node)
NodeUtils::AllDescendantsOfType";


// File: DistributionHandler_8cpp.xml


// File: DistributionHandler_8h.xml


// File: Distributions_8cpp.xml


// File: Distributions_8h.xml


// File: ParameterDistribution_8cpp.xml


// File: ParameterDistribution_8h.xml


// File: ParameterSample_8h.xml


// File: RangedDistributions_8cpp.xml


// File: RangedDistributions_8h.xml


// File: INode_8cpp.xml


// File: INode_8h.xml


// File: NodeUtils_8h.xml


// File: dir_dabc42ad3745509abd3a496944bb880e.xml


// File: dir_a98fb20d64e2aea67a6e042d91197081.xml


// File: dir_d452a16c8784395bb8c21da516e88a7f.xml

