
// File: index.xml

// File: classCoheringSubparticles.xml
%feature("docstring") CoheringSubparticles "

A set of particle slices that have fixed positions relative to each other. Accordingly, the collective form factor is computed by coherent superposition.

C++ includes: CoheringSubparticles.h
";

%feature("docstring")  CoheringSubparticles::CoheringSubparticles "CoheringSubparticles::CoheringSubparticles(double abundance, OwningVector< IReParticle > &&terms)
CoheringSubparticles::CoheringSubparticles";

%feature("docstring")  CoheringSubparticles::~CoheringSubparticles "CoheringSubparticles::~CoheringSubparticles()
CoheringSubparticles::~CoheringSubparticles";

%feature("docstring")  CoheringSubparticles::summedFF "complex_t CoheringSubparticles::summedFF(const DiffuseElement &ele) const
CoheringSubparticles::summedFF";

%feature("docstring")  CoheringSubparticles::summedPolFF "SpinMatrix CoheringSubparticles::summedPolFF(const DiffuseElement &ele) const
CoheringSubparticles::summedPolFF";

%feature("docstring")  CoheringSubparticles::relativeAbundance "double CoheringSubparticles::relativeAbundance() const
CoheringSubparticles::relativeAbundance";

%feature("docstring")  CoheringSubparticles::radialExtension "double CoheringSubparticles::radialExtension() const
CoheringSubparticles::radialExtension";

%feature("docstring")  CoheringSubparticles::terms "const OwningVector< IReParticle > & CoheringSubparticles::terms() const
CoheringSubparticles::terms";


// File: classDecouplingApproximationStrategy.xml
%feature("docstring") DecouplingApproximationStrategy "

Strategy class to compute the total scattering from a particle layout in the decoupling approximation.

C++ includes: DecouplingApproximationStrategy.h
";

%feature("docstring")  DecouplingApproximationStrategy::DecouplingApproximationStrategy "DecouplingApproximationStrategy::DecouplingApproximationStrategy(const OwningVector< const CoheringSubparticles > &weighted_formfactors, const IInterference *iff, SimulationOptions sim_params, bool polarized)
DecouplingApproximationStrategy::DecouplingApproximationStrategy";


// File: classDiffuseElement.xml
%feature("docstring") DiffuseElement "

Data stucture containing both input and output of a single detector cell.

C++ includes: DiffuseElement.h
";

%feature("docstring")  DiffuseElement::DiffuseElement "DiffuseElement::DiffuseElement(double wavelength, double alpha_i, double phi_i, std::unique_ptr< IPixel > pixel, const SpinMatrix &beam_polMatrices, const SpinMatrix &analyzer, bool isSpecular_, const Fluxes *fluxes_in=nullptr, const Fluxes *fluxes_out=nullptr)
DiffuseElement::DiffuseElement";

%feature("docstring")  DiffuseElement::DiffuseElement "DiffuseElement::DiffuseElement(const DiffuseElement &)=delete
DiffuseElement::DiffuseElement";

%feature("docstring")  DiffuseElement::DiffuseElement "DiffuseElement::DiffuseElement(DiffuseElement &&)
DiffuseElement::DiffuseElement";

%feature("docstring")  DiffuseElement::~DiffuseElement "DiffuseElement::~DiffuseElement()
DiffuseElement::~DiffuseElement";

%feature("docstring")  DiffuseElement::setFluxes "void DiffuseElement::setFluxes(const Fluxes *fluxes_in, const Fluxes *fluxes_out)
DiffuseElement::setFluxes";

%feature("docstring")  DiffuseElement::fluxIn "const IFlux * DiffuseElement::fluxIn(size_t i_layer) const
DiffuseElement::fluxIn";

%feature("docstring")  DiffuseElement::fluxOut "const IFlux * DiffuseElement::fluxOut(size_t i_layer) const
DiffuseElement::fluxOut";

%feature("docstring")  DiffuseElement::pointElement "DiffuseElement DiffuseElement::pointElement(double x, double y) const
DiffuseElement::pointElement
Returns copy of this  DiffuseElement with k_f given by in-pixel coordinate x,y. 
";

%feature("docstring")  DiffuseElement::wavelength "double DiffuseElement::wavelength() const
DiffuseElement::wavelength";

%feature("docstring")  DiffuseElement::alphaI "double DiffuseElement::alphaI() const
DiffuseElement::alphaI";

%feature("docstring")  DiffuseElement::getPhiI "double DiffuseElement::getPhiI() const
DiffuseElement::getPhiI";

%feature("docstring")  DiffuseElement::alphaMean "double DiffuseElement::alphaMean() const
DiffuseElement::alphaMean";

%feature("docstring")  DiffuseElement::getPhiMean "double DiffuseElement::getPhiMean() const
DiffuseElement::getPhiMean";

%feature("docstring")  DiffuseElement::setIntensity "void DiffuseElement::setIntensity(double intensity)
DiffuseElement::setIntensity";

%feature("docstring")  DiffuseElement::addIntensity "void DiffuseElement::addIntensity(double intensity)
DiffuseElement::addIntensity";

%feature("docstring")  DiffuseElement::intensity "double DiffuseElement::intensity() const
DiffuseElement::intensity";

%feature("docstring")  DiffuseElement::getKi "R3 DiffuseElement::getKi() const
DiffuseElement::getKi";

%feature("docstring")  DiffuseElement::meanKf "R3 DiffuseElement::meanKf() const
DiffuseElement::meanKf";

%feature("docstring")  DiffuseElement::meanQ "R3 DiffuseElement::meanQ() const
DiffuseElement::meanQ";

%feature("docstring")  DiffuseElement::getQ "R3 DiffuseElement::getQ(double x, double y) const
DiffuseElement::getQ
Returns scattering vector Q, with Kf determined from in-pixel coordinates x,y. In-pixel coordinates take values from 0 to 1. 
";

%feature("docstring")  DiffuseElement::integrationFactor "double DiffuseElement::integrationFactor(double x, double y) const
DiffuseElement::integrationFactor";

%feature("docstring")  DiffuseElement::solidAngle "double DiffuseElement::solidAngle() const
DiffuseElement::solidAngle";

%feature("docstring")  DiffuseElement::alpha "double DiffuseElement::alpha(double x, double y) const
DiffuseElement::alpha";

%feature("docstring")  DiffuseElement::getPhi "double DiffuseElement::getPhi(double x, double y) const
DiffuseElement::getPhi";

%feature("docstring")  DiffuseElement::wavevectorInfo "WavevectorInfo DiffuseElement::wavevectorInfo() const
DiffuseElement::wavevectorInfo";

%feature("docstring")  DiffuseElement::isSpecular "bool DiffuseElement::isSpecular() const
DiffuseElement::isSpecular
Tells if simulation element corresponds to a specular peak. 
";


// File: classFluxes.xml
%feature("docstring") Fluxes "";


// File: classIFlux.xml
%feature("docstring") IFlux "

Interface to access reflection/transmission coefficients. Realized by  ScalarFlux and  MatrixFlux.

C++ includes: IFlux.h
";

%feature("docstring")  IFlux::~IFlux "virtual IFlux::~IFlux()=default
IFlux::~IFlux";

%feature("docstring")  IFlux::T1plus "virtual Spinor IFlux::T1plus() const =0
IFlux::T1plus
The following functions return the transmitted and reflected amplitudes for different incoming beam polarizations and eigenmodes 
";

%feature("docstring")  IFlux::R1plus "virtual Spinor IFlux::R1plus() const =0
IFlux::R1plus";

%feature("docstring")  IFlux::T2plus "virtual Spinor IFlux::T2plus() const =0
IFlux::T2plus";

%feature("docstring")  IFlux::R2plus "virtual Spinor IFlux::R2plus() const =0
IFlux::R2plus";

%feature("docstring")  IFlux::T1min "virtual Spinor IFlux::T1min() const =0
IFlux::T1min";

%feature("docstring")  IFlux::R1min "virtual Spinor IFlux::R1min() const =0
IFlux::R1min";

%feature("docstring")  IFlux::T2min "virtual Spinor IFlux::T2min() const =0
IFlux::T2min";

%feature("docstring")  IFlux::R2min "virtual Spinor IFlux::R2min() const =0
IFlux::R2min";

%feature("docstring")  IFlux::getKz "virtual Spinor IFlux::getKz() const =0
IFlux::getKz
Returns z-part of the two wavevector eigenmodes. 
";


// File: classIInterparticleStrategy.xml
%feature("docstring") IInterparticleStrategy "

Abstract base class of  DecouplingApproximationStrategy,  SSCAStrategy. Provides function 'evaluate' that computes the total scattering intensity from a decorated layer.

Instantiation of child classes takes place in LayoutStrategyBuilder::createStrategy, which is called from ParticleLayoutContribution::eval.

C++ includes: IInterparticleStrategy.h
";

%feature("docstring")  IInterparticleStrategy::IInterparticleStrategy "IInterparticleStrategy::IInterparticleStrategy(const OwningVector< const CoheringSubparticles > &weighted_formfactors, const SimulationOptions &sim_params, bool polarized)
IInterparticleStrategy::IInterparticleStrategy";

%feature("docstring")  IInterparticleStrategy::~IInterparticleStrategy "IInterparticleStrategy::~IInterparticleStrategy()
IInterparticleStrategy::~IInterparticleStrategy";

%feature("docstring")  IInterparticleStrategy::evaluate "double IInterparticleStrategy::evaluate(const DiffuseElement &ele) const
IInterparticleStrategy::evaluate
Calculates the intensity for scalar particles/interactions. 
";


// File: classIntegratorMCMiser.xml
%feature("docstring") IntegratorMCMiser "";


// File: classIReParticle.xml
%feature("docstring") IReParticle "

Abstract base class for reprocessed particles.

Reprocessing is necessary to handle particles that cross material layers. These particles are divided into several.

C++ includes: IReParticle.h
";

%feature("docstring")  IReParticle::~IReParticle "IReParticle::~IReParticle() override
IReParticle::~IReParticle";

%feature("docstring")  IReParticle::clone "IReParticle * IReParticle::clone() const override=0
IReParticle::clone";

%feature("docstring")  IReParticle::setAmbientMaterial "virtual void IReParticle::setAmbientMaterial(const Material &)
IReParticle::setAmbientMaterial
Passes the material in which this particle is embedded. 
";

%feature("docstring")  IReParticle::theFF "virtual complex_t IReParticle::theFF(const WavevectorInfo &wavevectors) const =0
IReParticle::theFF
Returns scattering amplitude for complex wavevectors ki, kf. 
";

%feature("docstring")  IReParticle::radialExtension "virtual double IReParticle::radialExtension() const =0
IReParticle::radialExtension
Returns the (approximate in some cases) radial size of the particle of this form factor's shape. This is used for SSCA calculations 
";

%feature("docstring")  IReParticle::bottom_Z "virtual double IReParticle::bottom_Z(const IRotation *rotation) const =0
IReParticle::bottom_Z
Returns the z-coordinate of the lowest point in this shape after a given rotation. 
";

%feature("docstring")  IReParticle::top_Z "virtual double IReParticle::top_Z(const IRotation *rotation) const =0
IReParticle::top_Z
Returns the z-coordinate of the lowest point in this shape after a given rotation. 
";

%feature("docstring")  IReParticle::Z_span "ZLimits IReParticle::Z_span(const IRotation *rotation=nullptr) const
IReParticle::Z_span";

%feature("docstring")  IReParticle::thePolFF "SpinMatrix IReParticle::thePolFF(const WavevectorInfo &wavevectors) const
IReParticle::thePolFF
Returns scattering amplitude for matrix interactions. 
";

%feature("docstring")  IReParticle::volume "double IReParticle::volume() const
IReParticle::volume
Returns the total volume of the particle of this form factor's shape. 
";

%feature("docstring")  IReParticle::i_layer "const std::optional< size_t > & IReParticle::i_layer() const
IReParticle::i_layer";

%feature("docstring")  IReParticle::i_layer_or_0 "size_t IReParticle::i_layer_or_0() const
IReParticle::i_layer_or_0";

%feature("docstring")  IReParticle::setLayerIndex "void IReParticle::setLayerIndex(size_t i)
IReParticle::setLayerIndex";

%feature("docstring")  IReParticle::coherentFF "complex_t IReParticle::coherentFF(const DiffuseElement &ele) const
IReParticle::coherentFF
Returns the coherent sum of the four DWBA terms for scalar scattering. 
";

%feature("docstring")  IReParticle::coherentPolFF "SpinMatrix IReParticle::coherentPolFF(const DiffuseElement &ele) const
IReParticle::coherentPolFF
Returns the coherent sum of the four DWBA terms for polarized scattering. 
";

%feature("docstring")  IReParticle::admixed "OneAdmixture IReParticle::admixed() const
IReParticle::admixed";

%feature("docstring")  IReParticle::admixedFraction "double IReParticle::admixedFraction() const
IReParticle::admixedFraction";

%feature("docstring")  IReParticle::setAdmixedFraction "void IReParticle::setAdmixedFraction(double fraction)
IReParticle::setAdmixedFraction";

%feature("docstring")  IReParticle::setAdmixedMaterial "void IReParticle::setAdmixedMaterial(const Material &material)
IReParticle::setAdmixedMaterial";


// File: classMatrixFlux.xml
%feature("docstring") MatrixFlux "

Specular reflection and transmission coefficients in a layer in case of magnetic interactions between the scattered particle and the layer.

C++ includes: MatrixFlux.h
";

%feature("docstring")  MatrixFlux::MatrixFlux "MatrixFlux::MatrixFlux(double kz_sign, const Spinor &eigenvalues, const R3 &b, double magnetic_SLD)
MatrixFlux::MatrixFlux";

%feature("docstring")  MatrixFlux::T1plus "Spinor MatrixFlux::T1plus() const override
MatrixFlux::T1plus
The following functions return the transmitted and reflected amplitudes for different incoming beam polarizations and eigenmodes 
";

%feature("docstring")  MatrixFlux::R1plus "Spinor MatrixFlux::R1plus() const override
MatrixFlux::R1plus";

%feature("docstring")  MatrixFlux::T2plus "Spinor MatrixFlux::T2plus() const override
MatrixFlux::T2plus";

%feature("docstring")  MatrixFlux::R2plus "Spinor MatrixFlux::R2plus() const override
MatrixFlux::R2plus";

%feature("docstring")  MatrixFlux::T1min "Spinor MatrixFlux::T1min() const override
MatrixFlux::T1min";

%feature("docstring")  MatrixFlux::R1min "Spinor MatrixFlux::R1min() const override
MatrixFlux::R1min";

%feature("docstring")  MatrixFlux::T2min "Spinor MatrixFlux::T2min() const override
MatrixFlux::T2min";

%feature("docstring")  MatrixFlux::R2min "Spinor MatrixFlux::R2min() const override
MatrixFlux::R2min";

%feature("docstring")  MatrixFlux::getKz "Spinor MatrixFlux::getKz() const override
MatrixFlux::getKz
Returns z-part of the two wavevector eigenmodes. 
";

%feature("docstring")  MatrixFlux::magneticSLD "double MatrixFlux::magneticSLD() const
MatrixFlux::magneticSLD";

%feature("docstring")  MatrixFlux::computeP "SpinMatrix MatrixFlux::computeP() const
MatrixFlux::computeP";

%feature("docstring")  MatrixFlux::computeInverseP "SpinMatrix MatrixFlux::computeInverseP() const
MatrixFlux::computeInverseP";

%feature("docstring")  MatrixFlux::computeDeltaMatrix "SpinMatrix MatrixFlux::computeDeltaMatrix(double thickness)
MatrixFlux::computeDeltaMatrix";

%feature("docstring")  MatrixFlux::getReflectionMatrix "SpinMatrix MatrixFlux::getReflectionMatrix() const
MatrixFlux::getReflectionMatrix";


// File: classProfileHelper.xml
%feature("docstring") ProfileHelper "

Object that can generate the material profile of a sample as a function of depth.

The generated profile contains the complex SLD for SLD materials and the parameters delta and beta for refractive index materials

C++ includes: ProfileHelper.h
";

%feature("docstring")  ProfileHelper::ProfileHelper "ProfileHelper::ProfileHelper(const SliceStack &stack)
ProfileHelper::ProfileHelper";

%feature("docstring")  ProfileHelper::~ProfileHelper "ProfileHelper::~ProfileHelper()=default
ProfileHelper::~ProfileHelper";

%feature("docstring")  ProfileHelper::calculateProfile "std::vector< complex_t > ProfileHelper::calculateProfile(const std::vector< double > &z_values) const
ProfileHelper::calculateProfile";

%feature("docstring")  ProfileHelper::defaultLimits "std::pair< double, double > ProfileHelper::defaultLimits() const
ProfileHelper::defaultLimits";


// File: classReCompound.xml
%feature("docstring") ReCompound "

A reprocessed Compound.

C++ includes: ReCompound.h
";

%feature("docstring")  ReCompound::ReCompound "ReCompound::ReCompound()=default
ReCompound::ReCompound";

%feature("docstring")  ReCompound::ReCompound "ReCompound::ReCompound(const std::optional< size_t > &i_layer)
ReCompound::ReCompound";

%feature("docstring")  ReCompound::~ReCompound "ReCompound::~ReCompound() override
ReCompound::~ReCompound";

%feature("docstring")  ReCompound::clone "ReCompound * ReCompound::clone() const override
ReCompound::clone";

%feature("docstring")  ReCompound::radialExtension "double ReCompound::radialExtension() const override
ReCompound::radialExtension
Returns the (approximate in some cases) radial size of the particle of this form factor's shape. This is used for SSCA calculations 
";

%feature("docstring")  ReCompound::bottom_Z "double ReCompound::bottom_Z(const IRotation *rotation) const override
ReCompound::bottom_Z
Returns the z-coordinate of the lowest point in this shape after a given rotation. 
";

%feature("docstring")  ReCompound::top_Z "double ReCompound::top_Z(const IRotation *rotation) const override
ReCompound::top_Z
Returns the z-coordinate of the lowest point in this shape after a given rotation. 
";

%feature("docstring")  ReCompound::addFormFactor "void ReCompound::addFormFactor(const IReParticle &formfactor)
ReCompound::addFormFactor";

%feature("docstring")  ReCompound::setAmbientMaterial "void ReCompound::setAmbientMaterial(const Material &material) override
ReCompound::setAmbientMaterial
Passes the material in which this particle is embedded. 
";

%feature("docstring")  ReCompound::theFF "complex_t ReCompound::theFF(const WavevectorInfo &wavevectors) const override
ReCompound::theFF
Returns scattering amplitude for complex wavevectors ki, kf. 
";

%feature("docstring")  ReCompound::thePolFF "SpinMatrix ReCompound::thePolFF(const WavevectorInfo &wavevectors) const override
ReCompound::thePolFF
Calculates and returns a polarized form factor calculation in DWBA. 
";


// File: classReLayout.xml
%feature("docstring") ReLayout "

Data structure that contains preprocessed data for a single layout.

It is set by the preprocessor makeReLayout in  ReSample.cpp.

C++ includes: ReLayout.h
";

%feature("docstring")  ReLayout::ReLayout "ReLayout::ReLayout(double surface_density, OwningVector< const CoheringSubparticles > &&particles, const IInterference *iff)
ReLayout::ReLayout";

%feature("docstring")  ReLayout::ReLayout "ReLayout::ReLayout(ReLayout &&other)
ReLayout::ReLayout";

%feature("docstring")  ReLayout::~ReLayout "ReLayout::~ReLayout()
ReLayout::~ReLayout";

%feature("docstring")  ReLayout::surfaceDensity "double ReLayout::surfaceDensity() const
ReLayout::surfaceDensity";

%feature("docstring")  ReLayout::subparticles "const OwningVector< const CoheringSubparticles > & ReLayout::subparticles() const
ReLayout::subparticles";

%feature("docstring")  ReLayout::interferenceFunction "const IInterference * ReLayout::interferenceFunction() const
ReLayout::interferenceFunction";


// File: classReMesocrystal.xml
%feature("docstring") ReMesocrystal "

A reprocessed Mesocrystal.

C++ includes: ReMesocrystal.h
";

%feature("docstring")  ReMesocrystal::ReMesocrystal "ReMesocrystal::ReMesocrystal(const std::optional< size_t > &i_layer, const Lattice3D &lattice, const IReParticle &basis, const ReParticle &outer_shape, double position_variance=0.0)
ReMesocrystal::ReMesocrystal";

%feature("docstring")  ReMesocrystal::~ReMesocrystal "ReMesocrystal::~ReMesocrystal() override
ReMesocrystal::~ReMesocrystal";

%feature("docstring")  ReMesocrystal::clone "ReMesocrystal * ReMesocrystal::clone() const override
ReMesocrystal::clone";

%feature("docstring")  ReMesocrystal::setAmbientMaterial "void ReMesocrystal::setAmbientMaterial(const Material &material) override
ReMesocrystal::setAmbientMaterial
Passes the material in which this particle is embedded. 
";

%feature("docstring")  ReMesocrystal::volume "double ReMesocrystal::volume() const override
ReMesocrystal::volume
Returns the total volume of the particle of this form factor's shape. 
";

%feature("docstring")  ReMesocrystal::radialExtension "double ReMesocrystal::radialExtension() const override
ReMesocrystal::radialExtension
Returns the (approximate in some cases) radial size of the particle of this form factor's shape. This is used for SSCA calculations 
";

%feature("docstring")  ReMesocrystal::bottom_Z "double ReMesocrystal::bottom_Z(const IRotation *rotation) const override
ReMesocrystal::bottom_Z
Returns the z-coordinate of the lowest point in this shape after a given rotation. 
";

%feature("docstring")  ReMesocrystal::top_Z "double ReMesocrystal::top_Z(const IRotation *rotation) const override
ReMesocrystal::top_Z
Returns the z-coordinate of the lowest point in this shape after a given rotation. 
";

%feature("docstring")  ReMesocrystal::theFF "complex_t ReMesocrystal::theFF(const WavevectorInfo &wavevectors) const override
ReMesocrystal::theFF
Returns scattering amplitude for complex wavevectors ki, kf. 
";

%feature("docstring")  ReMesocrystal::thePolFF "SpinMatrix ReMesocrystal::thePolFF(const WavevectorInfo &wavevectors) const override
ReMesocrystal::thePolFF
Returns scattering amplitude for matrix interactions. 
";


// File: classReParticle.xml
%feature("docstring") ReParticle "

A reprocessed simple particle, with shape m_ff.

C++ includes: ReParticle.h
";

%feature("docstring")  ReParticle::ReParticle "ReParticle::ReParticle(const IFormFactor &ff)
ReParticle::ReParticle";

%feature("docstring")  ReParticle::~ReParticle "ReParticle::~ReParticle() override
ReParticle::~ReParticle";

%feature("docstring")  ReParticle::clone "ReParticle * ReParticle::clone() const override
ReParticle::clone";

%feature("docstring")  ReParticle::setMaterial "void ReParticle::setMaterial(const Material &material)
ReParticle::setMaterial
Sets the material of the scatterer. 
";

%feature("docstring")  ReParticle::setAmbientMaterial "void ReParticle::setAmbientMaterial(const Material &ambient_material) override
ReParticle::setAmbientMaterial
Sets the ambient material. 
";

%feature("docstring")  ReParticle::setPosition "void ReParticle::setPosition(const R3 &position)
ReParticle::setPosition";

%feature("docstring")  ReParticle::setRotMatrix "void ReParticle::setRotMatrix(const RotMatrix &rotMatrix)
ReParticle::setRotMatrix";

%feature("docstring")  ReParticle::theFF "complex_t ReParticle::theFF(const WavevectorInfo &wavevectors) const override
ReParticle::theFF
Returns scattering amplitude for complex wavevectors ki, kf. 
";

%feature("docstring")  ReParticle::thePolFF "SpinMatrix ReParticle::thePolFF(const WavevectorInfo &wavevectors) const override
ReParticle::thePolFF
Returns scattering amplitude for matrix interactions. 
";

%feature("docstring")  ReParticle::volume "double ReParticle::volume() const override
ReParticle::volume
Returns the total volume of the particle of this form factor's shape. 
";

%feature("docstring")  ReParticle::radialExtension "double ReParticle::radialExtension() const override
ReParticle::radialExtension
Returns the (approximate in some cases) radial size of the particle of this form factor's shape. This is used for SSCA calculations 
";

%feature("docstring")  ReParticle::bottom_Z "double ReParticle::bottom_Z(const IRotation *rotation) const override
ReParticle::bottom_Z
Returns the z-coordinate of the lowest point in this shape after a given rotation. 
";

%feature("docstring")  ReParticle::top_Z "double ReParticle::top_Z(const IRotation *rotation) const override
ReParticle::top_Z
Returns the z-coordinate of the lowest point in this shape after a given rotation. 
";

%feature("docstring")  ReParticle::formfactor_at_bottom "const IFormFactor * ReParticle::formfactor_at_bottom() const
ReParticle::formfactor_at_bottom";

%feature("docstring")  ReParticle::formfactor_at_bottom "complex_t ReParticle::formfactor_at_bottom(C3 q) const
ReParticle::formfactor_at_bottom";


// File: classReSample.xml
%feature("docstring") ReSample "

Data structure that contains all the necessary data for scattering calculations.

If the usage of average materials is requested, layers and particles are sliced into multiple slices and the average material is calculated for each slice.

C++ includes: ReSample.h
";

%feature("docstring")  ReSample::ReSample "ReSample::ReSample(const ReSample &)=delete
ReSample::ReSample";

%feature("docstring")  ReSample::~ReSample "ReSample::~ReSample()
ReSample::~ReSample";

%feature("docstring")  ReSample::numberOfSlices "size_t ReSample::numberOfSlices() const
ReSample::numberOfSlices";

%feature("docstring")  ReSample::averageSlices "const SliceStack & ReSample::averageSlices() const
ReSample::averageSlices";

%feature("docstring")  ReSample::avgeSlice "const Slice & ReSample::avgeSlice(size_t i) const
ReSample::avgeSlice";

%feature("docstring")  ReSample::layouts "const std::vector< ReLayout > & ReSample::layouts() const
ReSample::layouts";

%feature("docstring")  ReSample::sliceTopZ "double ReSample::sliceTopZ(size_t i) const
ReSample::sliceTopZ";

%feature("docstring")  ReSample::sliceBottomZ "double ReSample::sliceBottomZ(size_t i) const
ReSample::sliceBottomZ";

%feature("docstring")  ReSample::containsMagneticMaterial "bool ReSample::containsMagneticMaterial() const
ReSample::containsMagneticMaterial";

%feature("docstring")  ReSample::polarizing "bool ReSample::polarizing() const
ReSample::polarizing
Contains magnetic material, or nonzero magnetic field. 
";

%feature("docstring")  ReSample::hasRoughness "bool ReSample::hasRoughness() const
ReSample::hasRoughness";

%feature("docstring")  ReSample::sample "const MultiLayer & ReSample::sample() const
ReSample::sample";

%feature("docstring")  ReSample::fluxesIn "Fluxes ReSample::fluxesIn(const R3 &k) const
ReSample::fluxesIn";

%feature("docstring")  ReSample::fluxesOut "Fluxes ReSample::fluxesOut(const R3 &k) const
ReSample::fluxesOut";

%feature("docstring")  ReSample::crossCorrSpectralFun "double ReSample::crossCorrSpectralFun(R3 kvec, size_t j, size_t k) const
ReSample::crossCorrSpectralFun
Fourier transform of the correlation function of roughnesses between the interfaces. 
";


// File: classScalarFlux.xml
%feature("docstring") ScalarFlux "

Specular reflection and transmission coefficients in a layer in case of scalar interactions between the layers and the scattered particle.

C++ includes: ScalarFlux.h
";

%feature("docstring")  ScalarFlux::ScalarFlux "ScalarFlux::ScalarFlux(complex_t kz, Spinor TR)
ScalarFlux::ScalarFlux";

%feature("docstring")  ScalarFlux::T1plus "Spinor ScalarFlux::T1plus() const override
ScalarFlux::T1plus
The following functions return the transmitted and reflected amplitudes for different incoming beam polarizations and eigenmodes 
";

%feature("docstring")  ScalarFlux::R1plus "Spinor ScalarFlux::R1plus() const override
ScalarFlux::R1plus";

%feature("docstring")  ScalarFlux::T2plus "Spinor ScalarFlux::T2plus() const override
ScalarFlux::T2plus";

%feature("docstring")  ScalarFlux::R2plus "Spinor ScalarFlux::R2plus() const override
ScalarFlux::R2plus";

%feature("docstring")  ScalarFlux::T1min "Spinor ScalarFlux::T1min() const override
ScalarFlux::T1min";

%feature("docstring")  ScalarFlux::R1min "Spinor ScalarFlux::R1min() const override
ScalarFlux::R1min";

%feature("docstring")  ScalarFlux::T2min "Spinor ScalarFlux::T2min() const override
ScalarFlux::T2min";

%feature("docstring")  ScalarFlux::R2min "Spinor ScalarFlux::R2min() const override
ScalarFlux::R2min";

%feature("docstring")  ScalarFlux::getKz "Spinor ScalarFlux::getKz() const override
ScalarFlux::getKz
Returns z-part of the two wavevector eigenmodes. 
";

%feature("docstring")  ScalarFlux::getScalarT "complex_t ScalarFlux::getScalarT() const
ScalarFlux::getScalarT";

%feature("docstring")  ScalarFlux::getScalarR "complex_t ScalarFlux::getScalarR() const
ScalarFlux::getScalarR";

%feature("docstring")  ScalarFlux::getScalarKz "complex_t ScalarFlux::getScalarKz() const
ScalarFlux::getScalarKz";


// File: classSimulationOptions.xml
%feature("docstring") SimulationOptions "

Collect the different options for simulation.

SimulationOptions

C++ includes: SimulationOptions.h
";

%feature("docstring")  SimulationOptions::SimulationOptions "SimulationOptions::SimulationOptions()
SimulationOptions::SimulationOptions";

%feature("docstring")  SimulationOptions::isIntegrate "bool SimulationOptions::isIntegrate() const
SimulationOptions::isIntegrate";

%feature("docstring")  SimulationOptions::getMcPoints "size_t SimulationOptions::getMcPoints() const
SimulationOptions::getMcPoints";

%feature("docstring")  SimulationOptions::setMonteCarloIntegration "void SimulationOptions::setMonteCarloIntegration(bool flag=true, size_t mc_points=50)
SimulationOptions::setMonteCarloIntegration
Enables/disables MonetCarlo integration.

Parameters:
-----------

flag: 
If true, MonteCarlo integration will be used, otherwise analytical calculations

mc_points: 
Number of points for MonteCarlo integrator 
";

%feature("docstring")  SimulationOptions::setNumberOfThreads "void SimulationOptions::setNumberOfThreads(int nthreads)
SimulationOptions::setNumberOfThreads
Sets number of threads to use during the simulation (0 - take the default value from the hardware) 
";

%feature("docstring")  SimulationOptions::getNumberOfThreads "unsigned SimulationOptions::getNumberOfThreads() const
SimulationOptions::getNumberOfThreads";

%feature("docstring")  SimulationOptions::setNumberOfBatches "void SimulationOptions::setNumberOfBatches(int nbatches)
SimulationOptions::setNumberOfBatches
Sets number of batches to split. 
";

%feature("docstring")  SimulationOptions::getNumberOfBatches "unsigned SimulationOptions::getNumberOfBatches() const
SimulationOptions::getNumberOfBatches";

%feature("docstring")  SimulationOptions::getCurrentBatch "unsigned SimulationOptions::getCurrentBatch() const
SimulationOptions::getCurrentBatch";

%feature("docstring")  SimulationOptions::setThreadInfo "void SimulationOptions::setThreadInfo(const ThreadInfo &thread_info)
SimulationOptions::setThreadInfo
Sets the batch and thread information to be used. 
";

%feature("docstring")  SimulationOptions::getHardwareConcurrency "unsigned SimulationOptions::getHardwareConcurrency() const
SimulationOptions::getHardwareConcurrency";

%feature("docstring")  SimulationOptions::setIncludeSpecular "void SimulationOptions::setIncludeSpecular(bool include_specular)
SimulationOptions::setIncludeSpecular";

%feature("docstring")  SimulationOptions::includeSpecular "bool SimulationOptions::includeSpecular() const
SimulationOptions::includeSpecular";

%feature("docstring")  SimulationOptions::setUseAvgMaterials "void SimulationOptions::setUseAvgMaterials(bool use_avg_materials)
SimulationOptions::setUseAvgMaterials";

%feature("docstring")  SimulationOptions::useAvgMaterials "bool SimulationOptions::useAvgMaterials() const
SimulationOptions::useAvgMaterials";


// File: classSlice.xml
%feature("docstring") Slice "

Data structure containing the data of a single slice, for calculating the Fresnel coefficients.

C++ includes: Slice.h
";

%feature("docstring")  Slice::Slice "Slice::Slice(const ZLimits &zRange, Material material, const R3 &B_field, const LayerRoughness *roughness)
Slice::Slice";

%feature("docstring")  Slice::Slice "Slice::Slice(const Slice &other)
Slice::Slice";

%feature("docstring")  Slice::Slice "Slice::Slice(Slice &&other)
Slice::Slice";

%feature("docstring")  Slice::~Slice "Slice::~Slice()
Slice::~Slice";

%feature("docstring")  Slice::setMaterial "void Slice::setMaterial(const Material &material)
Slice::setMaterial";

%feature("docstring")  Slice::material "const Material & Slice::material() const
Slice::material";

%feature("docstring")  Slice::zBottom "double Slice::zBottom() const
Slice::zBottom";

%feature("docstring")  Slice::zTop "double Slice::zTop() const
Slice::zTop";

%feature("docstring")  Slice::zTopOr0 "double Slice::zTopOr0() const
Slice::zTopOr0";

%feature("docstring")  Slice::span "const ZLimits & Slice::span() const
Slice::span";

%feature("docstring")  Slice::thicknessOr0 "double Slice::thicknessOr0() const
Slice::thicknessOr0";

%feature("docstring")  Slice::topRoughness "const LayerRoughness * Slice::topRoughness() const
Slice::topRoughness";

%feature("docstring")  Slice::scalarReducedPotential "complex_t Slice::scalarReducedPotential(R3 k, double n_ref) const
Slice::scalarReducedPotential
Return the potential term that is used in the one-dimensional Fresnel calculations. 
";

%feature("docstring")  Slice::polarizedReducedPotential "SpinMatrix Slice::polarizedReducedPotential(R3 k, double n_ref) const
Slice::polarizedReducedPotential
Return the potential term that is used in the one-dimensional Fresnel calculations in the presence of magnetization 
";

%feature("docstring")  Slice::initBField "void Slice::initBField(R3 h_field, double h_z)
Slice::initBField
Initializes the magnetic B field from a given ambient field strength H. 
";

%feature("docstring")  Slice::bField "R3 Slice::bField() const
Slice::bField";

%feature("docstring")  Slice::invertBField "void Slice::invertBField()
Slice::invertBField";


// File: classSliceStack.xml
%feature("docstring") SliceStack "

A stack of  Slices.

C++ includes: SliceStack.h
";

%feature("docstring")  SliceStack::SliceStack "SliceStack::SliceStack(const RoughnessModel roughness_model)
SliceStack::SliceStack";

%feature("docstring")  SliceStack::SliceStack "SliceStack::SliceStack(const SliceStack &other)
SliceStack::SliceStack";

%feature("docstring")  SliceStack::addTopSlice "void SliceStack::addTopSlice(double zbottom, const Material &material)
SliceStack::addTopSlice";

%feature("docstring")  SliceStack::addSlice "void SliceStack::addSlice(double thickness, const Material &material, const LayerRoughness *roughness=nullptr)
SliceStack::addSlice";

%feature("docstring")  SliceStack::addNSlices "void SliceStack::addNSlices(size_t n, double thickness, const Material &material, const LayerRoughness *roughness=nullptr)
SliceStack::addNSlices
Adds n times the same slice to the stack. 
";

%feature("docstring")  SliceStack::setBField "SliceStack SliceStack::setBField(const R3 &externalField)
SliceStack::setBField";

%feature("docstring")  SliceStack::containsMagneticMaterial "bool SliceStack::containsMagneticMaterial() const
SliceStack::containsMagneticMaterial";

%feature("docstring")  SliceStack::bottomRoughness "const LayerRoughness * SliceStack::bottomRoughness(size_t i_slice) const
SliceStack::bottomRoughness";

%feature("docstring")  SliceStack::roughnessModel "RoughnessModel SliceStack::roughnessModel() const
SliceStack::roughnessModel";


// File: classSpecularElement.xml
%feature("docstring") SpecularElement "

Data stucture containing both input and output of a single image pixel for specular simulation.

C++ includes: SpecularElement.h
";

%feature("docstring")  SpecularElement::SpecularElement "SpecularElement::SpecularElement(const SpecularElement &other)=delete
SpecularElement::SpecularElement";

%feature("docstring")  SpecularElement::SpecularElement "SpecularElement::SpecularElement(SpecularElement &&other)
SpecularElement::SpecularElement";

%feature("docstring")  SpecularElement::~SpecularElement "SpecularElement::~SpecularElement()
SpecularElement::~SpecularElement";

%feature("docstring")  SpecularElement::intensity "double SpecularElement::intensity() const
SpecularElement::intensity";

%feature("docstring")  SpecularElement::setIntensity "void SpecularElement::setIntensity(double intensity)
SpecularElement::setIntensity";

%feature("docstring")  SpecularElement::isCalculated "bool SpecularElement::isCalculated() const
SpecularElement::isCalculated
Returns calculation flag (if it's false, zero intensity is assigned to the element) 
";

%feature("docstring")  SpecularElement::produceKz "std::vector< complex_t > SpecularElement::produceKz(const SliceStack &slices)
SpecularElement::produceKz
Returns kz values for Abeles computation of reflection/transition coefficients. 
";


// File: classSSCAStrategy.xml
%feature("docstring") SSCAStrategy "

Strategy class to compute the total scattering from a particle layout in the size-spacing correlation approximation.

C++ includes: SSCAStrategy.h
";

%feature("docstring")  SSCAStrategy::SSCAStrategy "SSCAStrategy::SSCAStrategy(const OwningVector< const CoheringSubparticles > &weighted_formfactors, const InterferenceRadialParacrystal *iff, SimulationOptions sim_params, bool polarized, double kappa)
SSCAStrategy::SSCAStrategy";


// File: classZLimits.xml
%feature("docstring") ZLimits "

An interval. Limits are of type double, and may be infinite. Used for the z-coordinate, especially when slicing form factors.

C++ includes: ZLimits.h
";

%feature("docstring")  ZLimits::ZLimits "ZLimits::ZLimits()
ZLimits::ZLimits";

%feature("docstring")  ZLimits::ZLimits "ZLimits::ZLimits(double _min, double _max)
ZLimits::ZLimits";

%feature("docstring")  ZLimits::isFinite "bool ZLimits::isFinite() const
ZLimits::isFinite";

%feature("docstring")  ZLimits::zBottom "double ZLimits::zBottom() const
ZLimits::zBottom";

%feature("docstring")  ZLimits::zTop "double ZLimits::zTop() const
ZLimits::zTop";

%feature("docstring")  ZLimits::zTopOr0 "double ZLimits::zTopOr0() const
ZLimits::zTopOr0";

%feature("docstring")  ZLimits::thickness "double ZLimits::thickness() const
ZLimits::thickness";

%feature("docstring")  ZLimits::thicknessOr0 "double ZLimits::thicknessOr0() const
ZLimits::thicknessOr0";

%feature("docstring")  ZLimits::contains "bool ZLimits::contains(double z) const
ZLimits::contains";

%feature("docstring")  ZLimits::intersects "bool ZLimits::intersects(const ZLimits &other) const
ZLimits::intersects";

%feature("docstring")  ZLimits::pair "std::pair< double, double > ZLimits::pair() const
ZLimits::pair";


// File: namespace_0d15.xml


// File: namespace_0d27.xml


// File: namespace_0d29.xml


// File: namespace_0d31.xml


// File: namespace_0d33.xml


// File: namespace_0d35.xml


// File: namespace_0d43.xml


// File: namespace_0d45.xml


// File: namespace_0d47.xml


// File: namespace_0d49.xml


// File: namespace_0d7.xml


// File: namespaceCompute.xml


// File: namespaceCompute_1_1Kz.xml
%feature("docstring")  Compute::Kz::computeReducedKz "std::vector< complex_t > Compute::Kz::computeReducedKz(const SliceStack &slices, R3 k)
Compute::Kz::computeReducedKz
Computes kz values from known k vector and slices with the following assumptions:
the beam penetrates fronting medium from a side

the wavelength is known for a distant point in vacuum (ref. index = 1)

the incident angle is known for the sample surface

This function is used in GISAS and off-spec computations mainly for back-compatibility reasons and should be replaced with computeKzFromRefIndices. 
";

%feature("docstring")  Compute::Kz::computeKzFromSLDs "std::vector< complex_t > Compute::Kz::computeKzFromSLDs(const SliceStack &slices, double kz)
Compute::Kz::computeKzFromSLDs
Computes kz values from kz of the incoming beam known at a distant point in vacuum. It is assumed, that the beam penetrates fronting medium from a side. 
";

%feature("docstring")  Compute::Kz::computeKzFromRefIndices "std::vector< complex_t > Compute::Kz::computeKzFromRefIndices(const SliceStack &slices, R3 k)
Compute::Kz::computeKzFromRefIndices
Computes kz values from k-vector of the incoming beam known at a distant point in vacuum. It is assumed, that the beam penetrates fronting medium from a side. 
";


// File: namespaceCompute_1_1MagneticNevotCroceTransition.xml
%feature("docstring")  Compute::MagneticNevotCroceTransition::backwardsSubmatrices "std::pair< SpinMatrix, SpinMatrix > Compute::MagneticNevotCroceTransition::backwardsSubmatrices(const MatrixFlux &coeff_i, const MatrixFlux &coeff_i1, double sigma)
Compute::MagneticNevotCroceTransition::backwardsSubmatrices";


// File: namespaceCompute_1_1Slicing.xml
%feature("docstring")  Compute::Slicing::particlesInSlice "OwningVector< IReParticle > Compute::Slicing::particlesInSlice(const IParticle *particle, const ZLimits &, const Material &ambientMat)
Compute::Slicing::particlesInSlice";

%feature("docstring")  Compute::Slicing::zSpan "ZLimits Compute::Slicing::zSpan(const IParticle *particle)
Compute::Slicing::zSpan";


// File: namespaceCompute_1_1SpecularMagnetic.xml
%feature("docstring")  Compute::SpecularMagnetic::fluxes "Fluxes Compute::SpecularMagnetic::fluxes(const SliceStack &slices, const R3 &k, bool forward)
Compute::SpecularMagnetic::fluxes
Computes refraction angle reflection/transmission coefficients for given sliced sample and wavevector k 
";

%feature("docstring")  Compute::SpecularMagnetic::topLayerR "SpinMatrix Compute::SpecularMagnetic::topLayerR(const SliceStack &slices, const std::vector< complex_t > &kzs, bool forward)
Compute::SpecularMagnetic::topLayerR
Computes the Fresnel R coefficient for the top layer only Introduced in order to speed up pure reflectivity computations 
";


// File: namespaceCompute_1_1SpecularScalar.xml
%feature("docstring")  Compute::SpecularScalar::fluxes "Fluxes Compute::SpecularScalar::fluxes(const SliceStack &slices, const R3 &k)
Compute::SpecularScalar::fluxes
Computes refraction angles and transmission/reflection coefficients for given coherent wave propagation in a sample. 
";

%feature("docstring")  Compute::SpecularScalar::topLayerR "complex_t Compute::SpecularScalar::topLayerR(const SliceStack &slices, const std::vector< complex_t > &kz)
Compute::SpecularScalar::topLayerR
Computes the Fresnel R coefficient for the top layer only. Introduced in order to speed up pure reflectivity computations. 
";


// File: namespaceCompute_1_1TransitionMagneticTanh.xml
%feature("docstring")  Compute::TransitionMagneticTanh::backwardsSubmatrices "std::pair< SpinMatrix, SpinMatrix > Compute::TransitionMagneticTanh::backwardsSubmatrices(const MatrixFlux &coeff_i, const MatrixFlux &coeff_i1, double sigma)
Compute::TransitionMagneticTanh::backwardsSubmatrices";


// File: namespacestd.xml


// File: namespaceswigAPI.xml
%feature("docstring")  swigAPI::generateZValues "std::vector< double > swigAPI::generateZValues(int n_points, double z_min, double z_max)
swigAPI::generateZValues";

%feature("docstring")  swigAPI::materialProfileSLD "std::vector< complex_t > swigAPI::materialProfileSLD(const MultiLayer &sample, int n_points, double z_min, double z_max)
swigAPI::materialProfileSLD
Calculate average material profile for given sample. 
";

%feature("docstring")  swigAPI::defaultMaterialProfileLimits "std::pair< double, double > swigAPI::defaultMaterialProfileLimits(const MultiLayer &sample)
swigAPI::defaultMaterialProfileLimits
Get default z limits for generating a material profile. 
";


// File: CoheringSubparticles_8cpp.xml


// File: CoheringSubparticles_8h.xml


// File: DiffuseElement_8cpp.xml


// File: DiffuseElement_8h.xml


// File: SpecularElement_8cpp.xml


// File: SpecularElement_8h.xml


// File: IFlux_8h.xml


// File: MatrixFlux_8cpp.xml


// File: MatrixFlux_8h.xml


// File: ScalarFlux_8cpp.xml


// File: ScalarFlux_8h.xml


// File: DecouplingApproximationStrategy_8cpp.xml


// File: DecouplingApproximationStrategy_8h.xml


// File: IInterparticleStrategy_8cpp.xml


// File: IInterparticleStrategy_8h.xml


// File: SSCAStrategy_8cpp.xml


// File: SSCAStrategy_8h.xml


// File: SimulationOptions_8cpp.xml


// File: SimulationOptions_8h.xml


// File: IReParticle_8cpp.xml


// File: IReParticle_8h.xml


// File: ReCompound_8cpp.xml


// File: ReCompound_8h.xml


// File: ReMesocrystal_8cpp.xml


// File: ReMesocrystal_8h.xml


// File: ReParticle_8cpp.xml


// File: ReParticle_8h.xml


// File: ReLayout_8cpp.xml


// File: ReLayout_8h.xml


// File: ReSample_8cpp.xml


// File: ReSample_8h.xml


// File: Slicer_8cpp.xml


// File: Slicer_8h.xml


// File: KzComputation_8cpp.xml


// File: KzComputation_8h.xml


// File: ProfileHelper_8cpp.xml


// File: ProfileHelper_8h.xml


// File: Slice_8cpp.xml


// File: Slice_8h.xml


// File: SliceStack_8cpp.xml


// File: SliceStack_8h.xml


// File: ZLimits_8cpp.xml


// File: ZLimits_8h.xml


// File: ComputeFluxMagnetic_8cpp.xml


// File: ComputeFluxMagnetic_8h.xml


// File: ComputeFluxScalar_8cpp.xml


// File: ComputeFluxScalar_8h.xml


// File: TransitionMagneticNevot_8cpp.xml


// File: TransitionMagneticNevot_8h.xml


// File: TransitionMagneticTanh_8cpp.xml


// File: TransitionMagneticTanh_8h.xml


// File: MultiLayerFuncs_8cpp.xml


// File: MultiLayerFuncs_8h.xml


// File: dir_05914d190eb55651e85671c4f064dae1.xml


// File: dir_28bc1277e419364b011e46aeb2e8e251.xml


// File: dir_4ab1bbd9e8de6a7ddc078bbf4801b604.xml


// File: dir_f2e99fd688553c1021427f9f47ee68cc.xml


// File: dir_fc04159ec4b49a4525d9d1e735a03048.xml


// File: dir_31af213eb35073f0536a9d5d1d1efa3a.xml


// File: dir_8b8e406e0c078f14186b4022c818284f.xml


// File: dir_dd8f7bdc5adb03cd4741fd30e320356d.xml


// File: dir_5a6fad4f9f1572339acc49c35f6f6afa.xml


// File: dir_1581d6c09e9e4d82c1ed930bcfd40548.xml


// File: dir_3d5d340a448876c17068ec92885910e5.xml

